import { TransformOptions } from "@babel/core";
import { WebpackConfigurer, WebpackContext } from "@webpackery/core";
import { RuleSetCondition, RuleSetRule } from "webpack";
export declare namespace BabelConfigurer {
    interface LoaderOptions extends TransformOptions {
        overrides?: TransformOptions[];
    }
    interface Props extends RuleSetRule {
        /**
         * @see RuleSetRule#test.
         * @default regex from {@link extensions}.
         */
        test?: RuleSetCondition;
        /**
         * Extensions to register for webpack resolution.
         * @default
         * - includes `.ts` when `@babel/preset-typescript` preset
         * - includes `.[jt]sx` when `@babel/react` preset
         */
        extensions?: string[];
        /** Babel loader options. */
        options?: LoaderOptions;
    }
}
export declare class BabelConfigurer extends WebpackConfigurer<BabelConfigurer.Props> {
    /** @inheritdoc */
    protected prepare(props: BabelConfigurer.Props, context: WebpackContext): BabelConfigurer.Props;
    /** @inheritdoc */
    protected configure(context: WebpackContext, props: BabelConfigurer.Props): void;
}
//# sourceMappingURL=babel-configurer.d.ts.map